"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _titoFindTicket = require("../services/tito-find-ticket");

var _redirectToLive = require("../utils/redirect-to-live");

var _TicketMessage = require("./TicketMessage.styled");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var RemindCode = function RemindCode(_ref) {
  var ticketsLink = _ref.ticketsLink;

  var _useState = (0, _react.useState)(''),
      _useState2 = _slicedToArray(_useState, 2),
      email = _useState2[0],
      changeEmail = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isLoading = _useState4[0],
      changeIsLoading = _useState4[1];

  var _useState5 = (0, _react.useState)(''),
      _useState6 = _slicedToArray(_useState5, 2),
      error = _useState6[0],
      setError = _useState6[1];

  var onInputChange = (0, _react.useCallback)(function (_ref2) {
    var value = _ref2.target.value;
    changeEmail(value);
  }, []);
  var handleTicketData = (0, _react.useCallback)(function (data) {
    var _data$data = data.data,
        isTicketExists = _data$data.isTicketExists,
        ticketCode = _data$data.code,
        dataError = data.error;

    if (error) {
      setError(dataError);
      changeIsLoading(false);
      return;
    }

    if (!isTicketExists) {
      changeIsLoading(false);
      setError('Sorry, we could not find your ticket. Please try other email, or contact the event team.');
      return;
    }

    changeIsLoading(false);
    (0, _redirectToLive.redirectToLivePage)(ticketCode);
  }, []);
  var onSubmit = (0, _react.useCallback)(function () {
    if (!email) {
      return;
    }

    changeIsLoading(true);
    (0, _titoFindTicket.titoFindTicket)(email, handleTicketData);
  }, [email]);
  var goBack = (0, _react.useCallback)(function (e) {
    e.preventDefault();
    setError('');
  }, []);
  return /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicket, {
    id: "popup-ticket"
  }, /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketColLeft, null, /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketTitle, null, "Find my registration"), !error && /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketDesc, null, "If you can't locate the email with the code (including in spam folder) from event team and ticketing system - please enter your email used to order the ticket and we will try matching it, once we found your order you will be redirected to the watch page."), error && /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketDesc, null, error, /*#__PURE__*/_react.default.createElement(_TicketMessage.ButtonsContainer, null, /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketButtonWithBorder, {
    href: "",
    onClick: goBack
  }, "Back"), /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketButtonWithBorder, {
    href: ticketsLink,
    target: "blank_"
  }, "Register"))), isLoading && /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketDesc, null, 'Loading...'), !isLoading && !error && /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketField, null, /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketInput, {
    type: "email",
    name: "email",
    placeholder: "Your email",
    value: email,
    onChange: onInputChange
  }), /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketSubmitButton, {
    onClick: onSubmit
  }, /*#__PURE__*/_react.default.createElement("span", null, "Find"), /*#__PURE__*/_react.default.createElement(_TicketMessage.PopTicketArrowSvg, null, /*#__PURE__*/_react.default.createElement("use", {
    xlinkHref: "img/sprite.svg#icon-arrow-right"
  }))))));
};

var _default = RemindCode;
exports.default = _default;